'From Squeak3.6 of ''6 October 2003'' [latest update: #5429] on 29 June 2004 at 10:54:17 pm'!
Object subclass: #DrySwitch
	instanceVariableNames: 'model '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Other'!

!DrySwitch commentStamp: 'Rik 6/29/2004 21:30' prior: 0!
I watch a pump and tell it to stopPumping if it goes dry

This does not always work!!!

Magnitude subclass: #InfoPipe
	instanceVariableNames: 'uid label latency inPorts outPorts ports pb '
	classVariableNames: 'LastUid '
	poolDictionaries: ''
	category: 'InfoPipes-Basic'!
InfoPipe subclass: #CompoundPipe
	instanceVariableNames: 'components activeComponents '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Compound'!

!CompoundPipe commentStamp: '<historical>' prior: 0!
A CompoundPipe encapsulates a variable number (> 0) of InfoPipe components.  A CompoundPipe is constructed from a set of infopipes that are connected together.  From the outside, the CompoundPipe can be treated as a "black box", that is, like a simple InfoPipe component.

This is all very well, except for messages like latency:.  What does it mean to set the latency of a CompoundPipe?


instance variables:
components -- an orderedCollection of all the components, might not be needed
activeComponents  --  all the pumps in the compound pipe!

Object subclass: #InfoPipeExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Examples'!
TestCase subclass: #InfoPipeTests
	instanceVariableNames: 'components '
	classVariableNames: 'ClassToUseForDict '
	poolDictionaries: ''
	category: 'InfoPipes-Examples'!
InfoPipeTests subclass: #InfoPipeClassTests
	instanceVariableNames: 'example '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Examples'!
InfoPipeTests subclass: #InfoPipeCleanUpTest
	instanceVariableNames: 'chaff '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Examples'!
InfoPipeClassTests subclass: #LimitedSequenceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Examples'!
Object subclass: #Mode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Modes'!
EllipseMorph subclass: #CircleMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Connectors-Base'!
InfoPipeTests subclass: #PipeLineTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Examples'!
InfoPipe subclass: #PseudoPipe
	instanceVariableNames: 'realPipe realPort '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Compound'!

!PseudoPipe commentStamp: '<historical>' prior: 0!
PseudoPipes exist to associate the ports of a CompoundPipe with the ports of its components. 

instance variables:
realPort  -- the port of the CompoundPipe this PseduoPipe associated wiht. A PseduoPipe can't be connected to a CompoundPort because the CompoundPort needs to be connected to the input or output of the CompoundPipe.!

PseudoPipe subclass: #InputPseudoPipe
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Compound'!

!InputPseudoPipe commentStamp: '<historical>' prior: 0!
An InputPseudoPipe associates an inport of a CompoundPipe with an inport of its upstream components. 

When pushing the inport of the CompoundPipe, it forwards the push message to the InputPseudoPipe, whose outport is connected to the inport of the component.

When pulling the inport of the component, it tryes to pull an item from the outport of the InputPseduoPipe, which forwards the pull message to the inport of the CompoundPipe.!

PseudoPipe subclass: #OutputPseudoPipe
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Compound'!

!OutputPseudoPipe commentStamp: '<historical>' prior: 0!
An OutputPseudoPipe associates an outport of a CompoundPipe with an outport of its downstream components. 

When pulling the outport of the CompoundPipe, it forwards the pull message to the OutputPseudoPipe, whose inport is connected to the outport of the component.

When pushing the outport of the component, it pushes an item to the inport of the OutputPseduoPipe, which forwards the push message to the outport of the CompoundPipe.!

InfoPipeClassTests subclass: #SinkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Examples'!
Mode subclass: #SoleInstanceMode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Modes'!
SoleInstanceMode subclass: #Active
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Modes'!
SoleInstanceMode subclass: #Passive
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Modes'!
SoleInstanceMode class
	instanceVariableNames: 'soleInstance '!
Source subclass: #SequentialSource
	instanceVariableNames: 'maxUsed '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Other'!
SequentialSource subclass: #LimitedSequence
	instanceVariableNames: 'limit '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Other'!

!LimitedSequence commentStamp: 'Rik 2/13/2004 15:31' prior: 0!
Represents a limited sequence of Integers!

InfoPipeClassTests subclass: #SourceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Examples'!
Filter subclass: #SquareFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RBK'!
Object subclass: #TopoSort
	instanceVariableNames: 'rows '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Other'!

!TopoSort commentStamp: 'Rik 2/29/2004 21:42' prior: 0!
For making a topological sort of infopipes to place them sensibly on screen.!

InfoPipeTests subclass: #UserPromptingTest
	instanceVariableNames: 'sysWin '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Examples'!
UserPromptingTest subclass: #Compound3Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Examples'!
UserPromptingTest subclass: #Compound4Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Examples'!
UserPromptingTest subclass: #CompoundPipeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Examples'!
UserPromptingTest subclass: #CompoundTeeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Examples'!
UserPromptingTest subclass: #LimitedStopTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Examples'!

!LimitedStopTest commentStamp: 'Rik 2/27/2004 01:35' prior: 0!
lst _ LimitedStopTest new.
lst setUp.
lst testStoppingAtLimit!

UserPromptingTest subclass: #MixTeeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Examples'!
UserPromptingTest subclass: #PipeLineTest2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Examples'!

!DrySwitch methodsFor: 'updating' stamp: 'Rik 6/29/2004 21:30'!
update: aSymbol
	aSymbol = #EndOfData ifFalse: [ self halt ].
	model stopPumping.! !

!DrySwitch methodsFor: 'initialize-release' stamp: 'Rik 2/27/2004 00:41'!
model: aPump
	model _ aPump.
	aPump addDependent: self
	! !


!DrySwitch class methodsFor: 'instance creation' stamp: 'Rik 2/27/2004 00:39'!
on: aPump
	^self new model: aPump! !


!Flaps class methodsFor: '*connectors-predefined flaps' stamp: 'Rik 3/11/2004 11:58'!
newClassDiagramConnectorsFlap
	"Answer a newly-created flap which adheres to the left edge of the screen and which holds prototypes of Connectors parts relevant to UML class diagrams."
	"Flaps newClassDiagramConnectorsFlap openInWorld; setToPopOutOnDragOver: false."

	|  aFlapTab aStrip |
	aStrip _ NCPartsBin newPartsBinWithOrientation: #topToBottom from: self quadsDefiningClassDiagramConnectorsFlap buttonClass: NCMakerButton.
 
	aFlapTab _ FlapTab new referent: aStrip beSticky.
	aFlapTab setName: 'Class Diagrams' edge: #right color: Color blue muchLighter.
	aFlapTab setBalloonText: aFlapTab balloonTextForFlapsMenu.

	aStrip beFlap: true.
	aStrip extent: (self currentWorld width @ 78).
	aStrip color: (Color blue muchLighter alpha: 0.8).
	aStrip submorphsDo: [ :ea | ea updateImage ].
	^aFlapTab
! !

!Flaps class methodsFor: '*connectors-predefined flaps' stamp: 'Rik 3/11/2004 11:59'!
newConnectorsFlap
	"Answer a newly-created flap which adheres to the left edge of the screen and which holds prototypes of Connectors parts."
	"Flaps newConnectorsFlap openInWorld; setToPopOutOnDragOver: false."

	|  aFlapTab aStrip |
	aStrip _ NCPartsBin newPartsBinWithOrientation: #topToBottom from: self quadsDefiningConnectorsFlap buttonClass: NCMakerButton.
 
	aFlapTab _ FlapTab new referent: aStrip beSticky.
	aFlapTab setName: 'Connectors' edge: #right color: Color blue muchLighter.
	aFlapTab setBalloonText: aFlapTab balloonTextForFlapsMenu.

	aStrip beFlap: true.
	aStrip extent: (self currentWorld width @ 78).
	aStrip color: (Color blue muchLighter alpha: 0.8).
	aStrip submorphsDo: [ :ea | ea updateImage ].
	^ aFlapTab
! !

!Flaps class methodsFor: '*connectors-predefined flaps' stamp: 'Rik 3/11/2004 11:58'!
newFSMConnectorsFlap
	"Answer a newly-created flap which adheres to the left edge of the screen and which holds prototypes of Connectors parts relevant to FSM diagrams."
	"Flaps newFSMConnectorsFlap openInWorld; setToPopOutOnDragOver: false."
	|  aFlapTab aStrip  |
	aStrip _ NCPartsBin newPartsBinWithOrientation: #topToBottom from: self quadsDefiningFSMConnectorsFlap buttonClass: NCMakerButton.
	aStrip submorphs third
		actionSelector: #startWiringLabeled: ;
		arguments: { 'event' }.

	aFlapTab _ FlapTab new referent: aStrip beSticky.
	aFlapTab setName: 'FSM' edge: #right color: (Color blue muchLighter).
	aFlapTab setBalloonText: aFlapTab balloonTextForFlapsMenu.

	aStrip beFlap: true.
	aStrip extent: (self currentWorld width @ 78).
	aStrip color: (Color blue muchLighter alpha: 0.8).
	aStrip submorphsDo: [ :ea | ea updateImage ].
	^ aFlapTab
! !

!Flaps class methodsFor: '*connectors-predefined flaps' stamp: 'Rik 3/8/2004 14:58'!
newPbConnectorsFlap
	"Answer a newly-created flap which adheres to the left edge of the screen and which holds prototypes of Connectors parts relevant to InFoPipe diagrams."
	"Flaps newPbConnectorsFlap openInWorld; setToPopOutOnDragOver: false."
	|  aFlapTab aStrip  |
	aStrip _ NCPartsBin newPartsBinWithOrientation: #topToBottom from: self quadsDefiningPbConnectorsFlap buttonClass: NCMakerButton.
	
	aFlapTab _ FlapTab new referent: aStrip beSticky.
	aFlapTab setName: 'Plumbing' edge: #right color: (Color cyan lighter).
	aFlapTab setBalloonText: aFlapTab balloonTextForFlapsMenu.

	aStrip beFlap: true.
	aStrip extent: (78 @ self currentWorld height).
	aStrip color: (Color cyan muchLighter alpha: 0.8).
	aStrip submorphsDo: [ :ea | ea updateImage ].
	^ aFlapTab
! !

!Flaps class methodsFor: '*connectors-predefined flaps' stamp: 'Rik 6/2/2004 09:49'!
quadsDefiningPbConnectorsFlap
	"Answer a structure defining the items on the default Pb flap"
	"Flaps newPbConnectorsFlap openInWorld; setToPopOutOnDragOver: false."

	^ #(
	(PbSource newStandAlone 'Source' 'A passive source')
	(PbPump newStandAlone 'Pump' 'A pump forces one-way flow')
	(PbFilter newStandAlone 'Filter' 'Processing might occur')
	(PbBuffer newStandAlone 'Buffer' 'A buffer can store an unlimited amount')
	(PbBoundedBuffer newStandAlone 'BoundedBuffer' 'A bounded buffer can store a little')
	(PbVPipe newStandAlone 'Vertical Pipe' 'A strait-through pipe (which shows strait vertically')
	(PbHPipe newStandAlone 'Horizontal Pipe' 'A strait-through pipe (which shows strait horizontally')
	(PbElbowNE newStandAlone 'Elbow, N & E' 'A strait-through pipe which shows as an elbow')
	(PbElbowSW newStandAlone 'Elbow, S & W' 'A strait-through pipe which shows as an elbow')
	(PbTeeS newStandAlone 'Tee, S' 'Careful: Tees can flow various ways')
	(PbTeeW newStandAlone 'Tee, W' 'Careful: Tees can flow various ways')
	(PbWye newStandAlone 'Wye' 'Y suggests flow direction')
	(PbNWayMerge newStandAlone 'Merge' 'Y suggests flow direction')
	(PbLambda newStandAlone 'Wye, inverted' 'Y suggests flow direction')
	(PbNWaySplit newStandAlone 'Split' 'Y suggests flow direction')
	(PbMtoN newStandAlone 'M to N' 'Escape for genericity')
	(PbSink newStandAlone 'Sink' 'The drain')
	)
! !


!InfoPipe methodsFor: 'clone' stamp: 'Rik 5/19/2004 01:25'!
copyPortsName: anInfoPipe 
	"For cloning.  
	Depends that a Dictionary answers keys and values in same order"
	|  portNames oldprts |	

	oldprts _ self ports values.
	portNames _ anInfoPipe ports keys as: OrderedCollection.
	ports _ Dictionary new.
	portNames with: oldprts do: [:name :port | ports at: name put: port].
! !

!InfoPipe methodsFor: 'user interface' stamp: 'Rik 2/29/2004 20:45'!
addConnectorsOnPipes:	allPipes	widget: widget inspectors: inspectors
	allPipes do: [:start | 
self shiftHalt.
			start outConnectedTo do: [:end | 
					| connector | 
					connector _ NCConnectorMorph
								fromMorph: (inspectors at: start)
								toMorph: (inspectors at: end)
								color: Color red twiceDarker
								width: 3.
					connector makeForwardArrow.
					connector connectToNearestPoint.
					widget addMorphBack: connector]].
! !

!InfoPipe methodsFor: 'user interface' stamp: 'Rik 2/29/2004 21:26'!
inspectPipeline
	"Create Inspectors for me and for all of the Infopipes to which I am 
	connected. "
	| inspectors allPipes sw widget topos zoomController scrollee |
	sw _ SystemWindow new.
	widget _ ZoomAndScrollMorph new.
	widget extent: 820 @ (Display extent y - 200);
		 borderWidth: 0.
	widget color: Color red darker darker.
	sw	addMorph: widget   frame: (0 @ 0 corner: 1 @ 1).
	scrollee _ widget submorphs first submorphs first.
	zoomController _ ZoomAndScrollControllerMorph new
			setBalloonText: 'Drag in here to zoom, tilt and pan the page above'.
	zoomController target: widget.
	sw addMorphFront: zoomController.

	inspectors _ Dictionary new.
	topos _ TopoSort new.
	allPipes _ self allConnectedInfoPipes.
	allPipes do: [:pipe | topos add: pipe ].
	topos places do: [ :assn |
		inspectors at: assn value put: (
			assn value inspectorIn: scrollee at: (self placesFor: assn key)).
		].
	self addConnectorsOnPipes: allPipes widget: scrollee inspectors: inspectors.
	sw bounds: (20 @ 3 extent: (widget extent x@(Display extent y - 20))).
	sw openAsIsIn: sw currentWorld.
	^ sw! !

!InfoPipe methodsFor: 'user interface' stamp: 'Rik 2/29/2004 19:04'!
inspectPipelinex
	"Create Inspectors for me and for all of the Infopipes to which I am 
	connected. "
	| inspectors allPipes sw widget place insp |
	inspectors _ Dictionary new.
	allPipes _ self allConnectedInfoPipes.
	sw _ SystemWindow new.
	widget _ ZoomAndScrollMorph new.
	widget extent: 820 @ Display extent y;
		 borderWidth: 0.
	widget color: Color red darker darker.
	sw	addMorph: widget   frame: (0 @ 0 corner: 1 @ 1).
	place _ 5 @ 5.
	allPipes do: [:pipe | 
			inspectors at: pipe put: (insp _ pipe inspectorIn: widget at: place).
			place _ place + (insp extent x + 19 @ 11).
			place x + insp extent x > widget extent x
				ifTrue: [place _ 5 @ (place y + 11 + insp extent y)]].
	allPipes do: [:start | 
			start outConnectedTo do: [:end | 
					| connector | 
					connector _ NCConnectorMorph
								fromMorph: (inspectors at: start)
								toMorph: (inspectors at: end)
								color: Color red twiceDarker
								width: 3.
					connector makeForwardArrow.
					connector connectToNearestPoint.
					widget addMorph: connector]].
	sw bounds: (0 @ 0 extent: widget extent + (30 @ 0)).
	sw openAsIsIn: sw currentWorld.
	^ sw! !

!InfoPipe methodsFor: 'user interface' stamp: 'Rik 2/29/2004 19:03'!
placesFor: aPoint 
	^(aPoint y - 1 * 290 + 5)@(aPoint x -1 * 300 + 7)

"
	 3@4 * (5@7) 15@28
"! !

!InfoPipe methodsFor: 'printing' stamp: 'Rik 2/29/2004 11:26'!
label
	label isNil ifTrue: [
		label _ 'Item'.
		].
	^label! !

!InfoPipe methodsFor: 'printing' stamp: 'Rik 2/29/2004 11:27'!
label: aString
	label _ aString! !

!InfoPipe methodsFor: 'printing' stamp: 'Rik 2/29/2004 11:28'!
printIDOn: aStream
	self label isNil ifFalse: [ aStream nextPutAll: self label; space ].
	uid printOn: aStream! !

!InfoPipe methodsFor: 'printing' stamp: 'Rik 2/29/2004 11:09'!
printOn: aStream 
	aStream nextPutAll: self class name; space.
	self printIDOn: aStream
! !

!InfoPipe methodsFor: 'initialize-release' stamp: 'Rik 2/18/2004 23:04'!
inPortMode
	self subclassResponsibility! !

!InfoPipe methodsFor: 'initialize-release' stamp: 'Rik 3/18/2004 11:38'!
initialize
	self initializeUid.
	self initializePorts.
	self latency: 3.! !

!InfoPipe methodsFor: 'initialize-release' stamp: 'Rik 2/18/2004 23:06'!
initializeInPorts
	self portNamed: #input1
		put: ((InPort ownedBy: self)
				mode: self inPortMode new)! !

!InfoPipe methodsFor: 'initialize-release' stamp: 'Rik 2/19/2004 00:11'!
initializeOutPorts
	self portNamed: #output1
		put: ((OutPort ownedBy: self)
				mode: self outPortMode new)! !

!InfoPipe methodsFor: 'initialize-release' stamp: 'Rik 2/18/2004 23:04'!
outPortMode
	self subclassResponsibility! !

!InfoPipe methodsFor: 'initialize-release' stamp: 'Rik 5/19/2004 01:22'!
release
	super release.
	self ports do: [ :ea | ea release ].
	ports _ nil.
! !

!InfoPipe methodsFor: 'gomi' stamp: 'Rik 5/19/2004 02:02'!
inPortAt: name 
	self gomi.
	^self portNamed: name! !

!InfoPipe methodsFor: 'gomi' stamp: 'Rik 5/19/2004 02:06'!
nameOfInPort: anInPort 
self gomi. "unsent"
	^ self nameOfPort: anInPort ! !

!InfoPipe methodsFor: 'gomi' stamp: 'Rik 5/19/2004 01:30'!
nameOfOutPort: aPort 
self gomi. "unsent"
	^ self ports keyAtValue: aPort! !

!InfoPipe methodsFor: 'gomi' stamp: 'Rik 5/19/2004 01:28'!
openInPorts
	| result |
self gomi.
	result _ Set new.
	self inPorts do: [:eachPort |
		eachPort infoPipeConnectedTo 
			ifNil: [ result add: eachPort]].
	^ result! !

!InfoPipe methodsFor: 'gomi' stamp: 'Rik 5/19/2004 01:31'!
openOutPorts
self gomi. "unsent"! !

!InfoPipe methodsFor: 'gomi' stamp: 'Rik 5/19/2004 01:19'!
outPortAt: name 
self gomi.
	^self  portNamed: name! !

!InfoPipe methodsFor: 'gomi' stamp: 'Rik 5/19/2004 02:07'!
replaceInPortName: oldName with: newName 
	| port |
self gomi. "unsent"
	(self inPorts includesKey: newName)
		ifTrue: [self error: 'repeated names for inports']
		ifFalse: 
			[port _ self inPorts at: oldName.
			self inPorts removeKey: oldName.
			self inPorts at: newName put: port]! !

!InfoPipe methodsFor: 'gomi' stamp: 'Rik 5/19/2004 01:34'!
replaceOutPortName: oldName with: newName 
	| port |
self gomi. "only sender was a dubious one in a test"
	(self outPorts includesKey: newName)
		ifTrue: [self error: 'repeated names in outPorts']
		ifFalse: 
			[port _ self outPorts at: oldName.
			self outPorts removeKey: oldName.
			self outPorts at: newName put: port]! !

!InfoPipe methodsFor: 'accessing' stamp: 'Rik 5/19/2004 01:29'!
disconnect
	self ports do: [:ea | ea disconnect].
	self initializePorts! !

!InfoPipe methodsFor: 'accessing' stamp: 'Rik 5/19/2004 01:21'!
inPorts
	^self ports select: [ :each | each isInput]! !

!InfoPipe methodsFor: 'accessing' stamp: 'Rik 5/19/2004 02:03'!
nameOfPort: anPort 
	^ self ports keyAtValue: anPort! !

!InfoPipe methodsFor: 'accessing' stamp: 'Rik 5/19/2004 01:28'!
openPorts
	| result |
	result _ Set new.
	self ports do: [:eachPort |
		eachPort infoPipeConnectedTo 
			ifNil: [ result add: eachPort]].
	^ result! !

!InfoPipe methodsFor: 'accessing' stamp: 'Rik 5/19/2004 01:21'!
outPorts
	^self ports select: [ :each | each isOutput]! !

!InfoPipe methodsFor: 'accessing' stamp: 'Rik 5/19/2004 01:38'!
portsConnectedTo
	^self ports collectNonNil: [ :ea | ea infoPipeConnectedTo] ! !

!InfoPipe methodsFor: 'configuration' stamp: 'Rik 5/19/2004 01:39'!
connectedInfoPipes: seen 
	| infoPipes |
	seen add: self.
	infoPipes _ Set new.
	infoPipes add: self.
	self portsConnectedTo do: [:aBranch | (seen includes: aBranch)
			ifFalse: [infoPipes addAll: (aBranch connectedInfoPipes: seen)]].
	^ infoPipes! !

!InfoPipe methodsFor: 'comparing' stamp: 'Rik 2/27/2004 23:27'!
< anInfoPipe
	^self inConnectedTo size < anInfoPipe inConnectedTo size! !

!InfoPipe methodsFor: 'comparing' stamp: 'Rik 2/27/2004 18:32'!
= anInfoPipe 
	^self == anInfoPipe! !

!InfoPipe methodsFor: 'comparing' stamp: 'Rik 2/27/2004 18:34'!
hash
	^ self identityHash! !

!InfoPipe methodsFor: 'plumbing' stamp: 'Rik 3/8/2004 12:27'!
pb
	^pb! !

!InfoPipe methodsFor: 'plumbing' stamp: 'Rik 3/8/2004 12:27'!
pb: aPBPartMorph
	pb _ aPBPartMorph
	! !

!InfoPipe methodsFor: 're-ports' stamp: 'Rik 5/19/2004 01:09'!
inPort
	^ self portNamed: #input1! !

!InfoPipe methodsFor: 're-ports' stamp: 'Rik 5/19/2004 01:09'!
outPort
	^self portNamed: #output1! !

!InfoPipe methodsFor: 're-ports' stamp: 'Rik 5/19/2004 01:06'!
portNamed: aSymbol
	^self ports at: aSymbol! !

!InfoPipe methodsFor: 're-ports' stamp: 'Rik 5/19/2004 01:06'!
portNamed: aSymbol put: aPort
	^self ports at: aSymbol put: aPort! !

!InfoPipe methodsFor: 're-ports' stamp: 'Rik 5/19/2004 00:43'!
ports
	ports isNil ifTrue: [ports _ Dictionary new].
	^ ports! !


!Buffer methodsFor: 'initialization' stamp: 'Rik 2/18/2004 23:08'!
inPortMode
	^Passive! !

!Buffer methodsFor: 'initialization' stamp: 'Rik 2/18/2004 23:08'!
outPortMode
	^Passive! !

!Buffer methodsFor: 'accessing' stamp: 'Rik 3/15/2004 10:33'!
contents
	^contents! !


!CompoundPipe methodsFor: 'initialization' stamp: 'H.J 11/20/2000 12:08'!
initialize
	super initialize.
	activeComponents _ OrderedCollection new.
	components do: [:each | each isActive ifTrue: [activeComponents add: each]]! !

!CompoundPipe methodsFor: 'initialization' stamp: 'Rik 5/19/2004 02:09'!
initializeInPorts
	self ports  "Just make the empty collection"! !

!CompoundPipe methodsFor: 'initialization' stamp: 'Rik 2/26/2004 00:50'!
initializeOutPorts
	self outPorts  "Just make the empty collection"! !

!CompoundPipe methodsFor: 'initialization' stamp: 'Rik 5/19/2004 02:04'!
initializePorts
	| prt tempName |
	super initializePorts.
	components do: [:ecmp | 
		ecmp openPorts do: 
			[:aPort | 
			prt _ aPort attachTo: self.
			tempName _ ecmp nameOfPort: aPort.
			(self ports includesKey: tempName)
				ifTrue: [self error: 'duplicate port name' , tempName asString].
			self portNamed: tempName put: prt].
		]
" 
components reject: [ :cmp | cmp openPorts isEmpty]
"! !

!CompoundPipe methodsFor: 'private' stamp: 'H.J 11/20/2000 12:03'!
components: infoPipeSet 
	components _ infoPipeSet! !

!CompoundPipe methodsFor: 'pump operations' stamp: 'HJ 10/29/2000 00:27'!
faster
	activeComponents do: [:c | c faster]! !

!CompoundPipe methodsFor: 'pump operations' stamp: 'HJ 10/29/2000 00:27'!
slower
	activeComponents do: [:c | c slower]! !

!CompoundPipe methodsFor: 'pump operations' stamp: 'HJ 10/29/2000 00:27'!
startPumping
	activeComponents do: [:c | c startPumping]! !

!CompoundPipe methodsFor: 'pump operations' stamp: 'HJ 10/29/2000 00:27'!
startPumping: millisecondInterval 
	activeComponents do: [:c | c startPumping: millisecondInterval]! !

!CompoundPipe methodsFor: 'pump operations' stamp: 'HJ 10/29/2000 00:27'!
stopPumping
	activeComponents do: [:c | c stopPumping]! !

!CompoundPipe methodsFor: 'pump operations' stamp: 'HJ 10/29/2000 00:27'!
stroke
	activeComponents do: [:c | c stroke]! !

!CompoundPipe methodsFor: 'pump operations' stamp: 'HJ 10/29/2000 00:27'!
stroke: aNumber 
	aNumber timesRepeat: [self stroke]! !

!CompoundPipe methodsFor: 'pump operations' stamp: 'HJ 10/29/2000 00:27'!
strokeInterval
	^ activeComponents anyOne strokeInterval! !

!CompoundPipe methodsFor: 'pump operations' stamp: 'HJ 10/29/2000 00:27'!
strokeInterval: millisecondInterval 
	activeComponents do: [:c | c strokeInterval: millisecondInterval]! !

!CompoundPipe methodsFor: 'testing' stamp: 'HJ 10/29/2000 00:27'!
isActive
	^ activeComponents size ~= 0! !

!CompoundPipe methodsFor: 'clone' stamp: 'Rik 5/19/2004 01:54'!
clone
	| old2new inName newTo oldTo |
	old2new _ Dictionary new.
	components do: [:p | old2new at: p put: p clone].
	old2new keysAndValuesDo: [:oldFrom :newFrom | oldFrom outPorts
			keysAndValuesDo: 
				[:outName :outPort | 
				oldTo _ outPort infoPipeConnectedTo.
				newTo _ old2new at: oldTo ifAbsent: [nil].
				newTo
					ifNotNil: 
						[inName _ oldTo inPorts keyAtValue: outPort connectedTo.
						(newFrom portNamed: outName)
							connect: (newTo portNamed: inName)]]].
	^ CompoundPipe fromComponent: (old2new at: components anyOne)! !

!CompoundPipe methodsFor: 'pipe operations' stamp: 'H.J 11/20/2000 15:01'!
pull
	self shouldNotImplement! !

!CompoundPipe methodsFor: 'pipe operations' stamp: 'H.J 11/20/2000 15:00'!
push: anItem 
	self shouldNotImplement! !


!Defragmentor methodsFor: 'initialization' stamp: 'Rik 2/18/2004 23:09'!
inPortMode
	^Active ! !

!Defragmentor methodsFor: 'initialization' stamp: 'Rik 2/18/2004 23:09'!
outPortMode
	^Passive! !


!InfoPipe class methodsFor: 'instance creation' stamp: 'Rik 3/8/2004 12:28'!
newForPb: aPBPartMorph
	^self new pb: aPBPartMorph! !


!CompoundPipe class methodsFor: 'instance creation' stamp: 'HJ 2/25/2001 23:33'!
from: anInfoPipeSet
	| c |
	c _ self basicNew.
	c components: anInfoPipeSet.
	c initialize.
	^ c! !

!CompoundPipe class methodsFor: 'instance creation' stamp: 'HJ 6/4/2001 14:09'!
fromComponent: anInfoPipe 
	| c |
	c _ self basicNew.
	c components: anInfoPipe allConnectedInfoPipes.
	c initialize.
	^ c! !


!InfoPipeExamples class methodsFor: 'netpipetest6' stamp: 'Rik 2004.5'!
testn6
	"InfoPipeExamples testn6"
	| source1 sink4 pump1 source3 pump3 netPipe4a netPipe4b pump4a pump4b merge4 |
	source1 _ 's2s://Infopipe1/source1' asRemoteObject.
	pump1 _ 's2s://Infopipe1/pump1' asRemoteObject.
	source3 _ 's2s://Infopipe3/source3' asRemoteObject.
	pump3 _ 's2s://Infopipe3/pump3' asRemoteObject.
	netPipe4a _ NetPipe from: 's2s://Infopipe1/'.
	netPipe4b _ NetPipe from: 's2s://Infopipe3/'.
	pump4a _ Pump new.
	pump4b _ Pump new.
	merge4 _ MixTee new.
	sink4 _ Sink new.
	source1 ->> pump1 ->> netPipe4a ->> pump4a.
	self halt.
	source3 ->> pump3 ->> netPipe4b ->> pump4b.
	pump4a outPort
		->> (merge4 inPort).
	pump4b outPort
		->> (merge4 portNamed: #input2).
	merge4 ->> sink4.
	pump1 startPumping: 1200.
	pump3 startPumping: 1200.
	pump4a startPumping: 1000.
	pump4b startPumping: 1500.
	sink4 inspect! !

!InfoPipeExamples class methodsFor: 'netpipetest5' stamp: 'Rik 2004.5'!
testn5
	"InfoPipeExamples testn5"
	| source1 netPipe2 netPipe4 pump4 sink4 split1 pump2 sink2 pump1a pump1b |
	source1 _ 's2s://Infopipe1/source1' asRemoteObject.
	pump1a _ 's2s://Infopipe1/pump1a' asRemoteObject.
	pump1b _ 's2s://Infopipe1/pump1b' asRemoteObject.
	split1 _ 's2s://Infopipe1/split1' asRemoteObject.
	netPipe2 _ 's2s://Infopipe2/netpipe2' asRemoteObject.
	pump2 _ 's2s://Infopipe2/pump2' asRemoteObject.
	sink2 _ 's2s://Infopipe2/sink2' asRemoteObject.
	netPipe4 _ NetPipe from: 's2s://Infopipe1/'.
	pump4 _ Pump new.
	sink4 _ Sink new.
	source1 ->> split1.
	(split1 outPort)
		->> pump1a inPort.
	(split1 portNamed: #output2)
		->> pump1b inPort.
	pump1a ->> netPipe2 ->> pump2 ->> sink2.
	pump1b ->> netPipe4 ->> pump4 ->> sink4.
	pump1a startPumping: 1200.
	pump1b startPumping: 1200.
	pump2 startPumping: 1000.
	pump4 startPumping: 1500.
	sink4 inspect! !

!InfoPipeExamples class methodsFor: 'netpipetest4' stamp: 'Rik 2004.5'!
testn4
	"InfoPipeExamples testn4"
	| source1 pump1 netPipe2 netPipe4 pump4 sink4 split1 pump2 sink2 |
	source1 _ 's2s://Infopipe1/source1' asRemoteObject.
	pump1 _ 's2s://Infopipe1/pump1' asRemoteObject.
	split1 _ 's2s://Infopipe1/split1' asRemoteObject.
	netPipe2 _ 's2s://Infopipe2/netpipe2' asRemoteObject.
	pump2 _ 's2s://Infopipe2/pump2' asRemoteObject.
	sink2 _ 's2s://Infopipe2/sink2' asRemoteObject.
	netPipe4 _ NetPipe from: 's2s://Infopipe1/'.
	pump4 _ Pump new.
	sink4 _ Sink new.
	source1 ->> pump1 ->> split1.
	(split1 outPort)
		->> netPipe2 inPort.
	(split1 portNamed: #output2)
		->> netPipe4 inPort.
	netPipe2 ->> pump2 ->> sink2.
	netPipe4 ->> pump4 ->> sink4.
	pump1 startPumping: 1200.
	pump2 startPumping: 1000.
	pump4 startPumping: 1500.
	sink4 inspect! !

!InfoPipeExamples class methodsFor: 'netpipetest11' stamp: 'Rik 2004.5'!
testn11
	"InfoPipeExamples testn11"
	| pump4a pump4b source1a source1b pump1a pump1b c1 sink4a sink4b set c4 split4 sink4c pump4c |
	source1a _ 's2s://Infopipe1/source1a' asRemoteObject.
	source1b _ 's2s://Infopipe1/source1b' asRemoteObject.
	pump1a _ 's2s://Infopipe1/pump1a' asRemoteObject.
	pump1b _ 's2s://Infopipe1/pump1b' asRemoteObject.
	c1 _ 's2s://Infopipe1/compound1' asRemoteObject.
	split4 _ SwitchTee new.
	pump4a _ Pump new.
	pump4b _ Pump new.
	pump4c _ Pump new.
	sink4a _ Sink new.
	sink4b _ Sink new.
	sink4c _ Sink new.
	set _ Set new.
	(c1 outPort)
		->> split4 inPort.
	set add: c1.
	set add: split4.
	c4 _ CompoundPipe from: set.
	source1a ->> pump1a.
	source1b ->> pump1b.
	pump1a outPort
		->> (c4 inPort).
	pump1b outPort
		->> (c4 portNamed: #input2).
	(c4 portNamed: #output2)
		->> pump4b inPort.
	(c4 outPort)
		->> pump4a inPort.
	pump4a ->> sink4a.
	pump4b ->> sink4b.
	pump1a startPumping: 1200.
	pump1b startPumping: 1000.
	pump4a startPumping: 1000.
	pump4b startPumping: 1500.
	sink4a inspect.
	sink4b inspect! !

!InfoPipeExamples class methodsFor: 'netpipetest10' stamp: 'Rik 2004.5'!
testn10
	"InfoPipeExamples testn10"
	| c1 set c4 source1 pump1 c2 sink4 |
	source1 _ 's2s://Infopipe1/source1' asRemoteObject.
	pump1 _ 's2s://Infopipe1/pump1' asRemoteObject.
	c1 _ 's2s://Infopipe1/compound1' asRemoteObject.
	c2 _ 's2s://Infopipe2/compound2' asRemoteObject.
	sink4 _ Sink new.
	set _ Set new.
	(c1 outPort)
		->> c2 inPort.
	set add: c1.
	set add: c2.
	c4 _ CompoundPipe from: set.
	source1 ->> pump1.
	pump1 outPort
		->> (c4 inPort).
	(c4 outPort)
		->> sink4 inPort.
	pump1 startPumping: 1200.
	c4 startPumping: 1000.
	sink4 inspect! !

!InfoPipeExamples class methodsFor: 'netpipetest9' stamp: 'Rik 2004.5'!
testn9
	"InfoPipeExamples testn9"
	| pump4a pump4b source1a source1b pump1a pump1b c1 sink4a sink4b set c4 |
	source1a _ 's2s://Infopipe1/source1a' asRemoteObject.
	source1b _ 's2s://Infopipe1/source1b' asRemoteObject.
	pump1a _ 's2s://Infopipe1/pump1a' asRemoteObject.
	pump1b _ 's2s://Infopipe1/pump1b' asRemoteObject.
	c1 _ 's2s://Infopipe1/compound1' asRemoteObject.
	pump4a _ Pump new.
	pump4b _ Pump new.
	sink4a _ Sink new.
	sink4b _ Sink new.
	set _ Set new.
	(c1 outPort)
		->> pump4a.
	set add: c1.
	set add: pump4a.
	c4 _ CompoundPipe from: set source1a ->> pump1a.
	source1a ->> pump1a.
	source1b ->> pump1b.
	pump1a outPort
		->> (c4 inPort).
	pump1b outPort
		->> (c4 portNamed: #input2).
	(c4 portNamed: #output2)
		->> pump4b inPort.
	(c4 outPort)
		->> sink4a.
	pump4b ->> sink4b.
	pump1a startPumping: 1200.
	pump1b startPumping: 1000.
	pump4a startPumping: 1000.
	pump4b startPumping: 1500.
	sink4a inspect.
	sink4b inspect! !

!InfoPipeExamples class methodsFor: 'netpipetest8' stamp: 'Rik 2004.5'!
testn8
	"InfoPipeExamples testn8"
	| pump4a pump4b source1a source1b pump1a pump1b c1 sink4a sink4b |
	source1a _ 's2s://Infopipe1/source1a' asRemoteObject.
	source1b _ 's2s://Infopipe1/source1b' asRemoteObject.
	pump1a _ 's2s://Infopipe1/pump1a' asRemoteObject.
	pump1b _ 's2s://Infopipe1/pump1b' asRemoteObject.
	c1 _ 's2s://Infopipe1/compound1' asRemoteObject.
	pump4a _ Pump new.
	pump4b _ Pump new.
	sink4a _ Sink new.
	sink4b _ Sink new.
	source1a ->> pump1a.
	source1b ->> pump1b.
	pump1a outPort
		->> (c1 inPort).
	pump1b outPort
		->> (c1 portNamed: #input2).
	c1 outPort ->> pump4a inPort.
	c1 portNamed: #output2 ->> pump4b inPort.
	pump4a ->> sink4a.
	pump4b ->> sink4b.
	pump1a startPumping: 1200.
	pump1b startPumping: 1000.
	pump4a startPumping: 1000.
	pump4b startPumping: 1500.
	sink4a inspect.
	sink4b inspect! !

!InfoPipeExamples class methodsFor: 'replaced by SUnits' stamp: 'Rik 2004.5'!
testc1
	"InfoPipeExamples testc1"
	"test compound pipe"
	| c s |
	c _ CompoundPipe fromComponent: Pump new ->> Pipe new ->> Pipe new ->> BoundedBuffer new ->> Pump new.
	SequentialSource new outPort
		->> (c inPort).
	(c outPort)
		->> (s _ Sink new) inPort.
	c startPumping: 500.
	s inspectPipeline.
	^ c! !

!InfoPipeExamples class methodsFor: 'replaced by SUnits' stamp: 'Rik 2004.5'!
testc2
	"InfoPipeExamples testc2"
	"test compound pipe"
	| c p1 p2 |
	c _ CompoundPipe fromComponent: MixTee new ->> BoundedBuffer new ->> SwitchTee new.
	c inspect.
	SequentialSource new ->> (p1 _ Pump new).
	p1 outPort
		->> (c inPort).
	(c portNamed: #output2)
		->> (p2 _ Pump new) inPort.
	(p2 ->> Sink new inspect) allConnectedInfoPipes inspect.
	p1 startPumping: 500.
	p2 startPumping: 300! !

!InfoPipeExamples class methodsFor: 'replaced by SUnits' stamp: 'Rik 2004.5'!
testc3
	"InfoPipeExamples testc3"
	"test compound pipe"
	| c p1 p2 p3 p4 |
	c _ CompoundPipe fromComponent: MixTee new ->> BoundedBuffer new ->> SwitchTee new.
	c inspect.
	SequentialSource new ->> (p1 _ Pump new).
	p1 outPort
		->> (c inPort).
	(c portNamed: #output2)
		->> (p2 _ Pump new) inPort.
	p2 ->> Sink new inspect.
	SequentialSource new ->> (p3 _ Pump new).
	p3 outPort
		->> (c portNamed: #input2).
	(c outPort)
		->> (p4 _ Pump new) inPort.
	(p4 ->> Sink new inspect) allConnectedInfoPipes inspect.
	p1 startPumping: 500.
	p2 startPumping: 300.
	p3 startPumping: 500.
	p4 startPumping: 300! !

!InfoPipeExamples class methodsFor: 'replaced by SUnits' stamp: 'Rik 2004.5'!
testc4
	"test compound pipe"
	"InfoPipeExamples testc4"
	| p c |
	( SwitchTee new outPort)
		->> (p _ Pump new) inPort.
	p outPort
		->> (MixTee new inPort).
	c _ CompoundPipe fromComponent: p.
	c inspect.
	SequentialSource new outPort
		->> (c inPort).
	(c outPort)
		->> Sink new inspect inPort.
	c startPumping: 500.
	(c portNamed: #output2)
		->> (p _ Pump new) inPort.
	p ->> Sink new inspect.
	p startPumping: 500.
	SequentialSource new outPort ->> (p _ Pump new) inPort.
	p outPort
		->> (c portNamed: #input2).
	p startPumping: 300.
	p allConnectedInfoPipes inspect! !

!InfoPipeExamples class methodsFor: 'simple examples' stamp: 'Rik 2004.5'!
testc5
	"InfoPipeExamples testc5"
	"a compound pipe in a compound pipe"
	| c1 c2 p1 p2 s |
	c1 _ CompoundPipe fromComponent: MixTee new ->> BoundedBuffer new ->> SwitchTee new.
	c1 inspect.
	(c1 outPort)
		->> (p2 _ Pump new) inPort.
	c2 _ CompoundPipe fromComponent: p2.
	c2 inspect.
	SequentialSource new ->> (p1 _ Pump new).
	p1 outPort
		->> (c2 inPort).
	(c2 outPort)
		->> (s _ Sink new inspect) inPort.
	s allConnectedInfoPipes inspect.
	p1 startPumping: 500.
	p2 startPumping: 300! !

!InfoPipeExamples class methodsFor: 'simple examples' stamp: 'Rik 2004.5'!
testc6
	"InfoPipeExamples testc6"
	"two compound pipes in a compound pipe"
	| c1 c2 c3 p s |
	c1 _ CompoundPipe fromComponent: MixTee new ->> BoundedBuffer new ->> SwitchTee new.
	c1 inspect.
	c2 _ CompoundPipe fromComponent: Pump new ->> Pipe new ->> Pipe new ->> BoundedBuffer new ->> Pump new.
	c2 inspect.
	(c1 outPort)
		->> (c2 inPort).
	c3 _ CompoundPipe fromComponent: c2.
	SequentialSource new ->> (p _ Pump new).
	p outPort
		->> (c3 inPort).
	(c3 outPort)
		->> (s _ Sink new inspect) inPort.
	s allConnectedInfoPipes inspect.
	p startPumping: 500.
	c3 startPumping: 300! !

!InfoPipeExamples class methodsFor: 'simple examples' stamp: 'Rik 2004.5'!
testc7
"InfoPipeExamples testc7"
	"a compound pipe in a compound pipe, in the case need to  
	change port name"
	| c1 c2 p1 p2 s s2 |
	c1 _ CompoundPipe fromComponent: MixTee new ->> BoundedBuffer new ->> SwitchTee new.
	c1 inspect.
	(c1 outPort)
		->> (s2 _ SwitchTee new) inPort.
	s2 replaceOutPortName: #output2 with: #myport2.
	(s2 outPort)
		->> (p2 _ Pump new) inPort.
	c2 _ CompoundPipe fromComponent: p2.
	c2 inspect.
	SequentialSource new ->> (p1 _ Pump new).
	p1 outPort
		->> (c2 inPort).
	(c2 outPort)
		->> (s _ Sink new inspect) inPort.
	s allConnectedInfoPipes inspect.
	p1 startPumping: 500.
	p2 startPumping: 300! !

!InfoPipeExamples class methodsFor: 'simple examples' stamp: 'Rik 2004.5'!
testclone1
"InfoPipeExamples testclone1"
	"test compound pipe"
	| c c2 |
	c _ CompoundPipe fromComponent: Pump new ->> Pipe new ->> Pipe new ->> BoundedBuffer new ->> Pump new.
	SequentialSource new outPort
		->> (c inPort).
	(c outPort)
		->> Sink new inspect inPort.
	c startPumping: 500.
	self halt.
	c2 _ c clone.
	SequentialSource new outPort
		->> (c2 inPort).
	(c2 outPort)
		->> Sink new inspect inPort.
	c2 startPumping: 500! !

!InfoPipeExamples class methodsFor: 'simple examples' stamp: 'Rik 2004.5'!
testclone2
	"InfoPipeExamples testclone2"
	"two compound pipes in a compound pipe"
	| c1 c2 c3 p c4 |
	c1 _ CompoundPipe fromComponent: MixTee new ->> BoundedBuffer new ->> SwitchTee new.
	c1 inspect.
	c2 _ CompoundPipe fromComponent: Pump new ->> Pipe new ->> Pipe new ->> BoundedBuffer new ->> Pump new.
	(c1 outPort)
		->> (c2 inPort).
	c3 _ CompoundPipe fromComponent: c2.
	SequentialSource new ->> (p _ Pump new).
	p outPort
		->> (c3 inPort).
	(c3 outPort)
		->> Sink new inspect inPort.
	p startPumping: 500.
	c3 startPumping: 300.
	c4 _ c3 clone.
	SequentialSource new ->> (p _ Pump new).
	p outPort
		->> (c4 inPort).
	(c4 outPort)
		->> Sink new inspect inPort.
	p startPumping: 500.
	c4 startPumping: 1000! !

!InfoPipeExamples class methodsFor: 'simple examples' stamp: 'Rik 2004.5'!
testy1
"InfoPipeExamples testy1"
	"only use the basic components and Y components to construct a  
	staight pipeline"
	rm _ OrderedCollection new.
	rm addLast: SequentialSource new.
	rm addLast: Pump new.
	self halt.
	rm addLast: MixTee new.
	rm addLast: BoundedBuffer new.
	rm addLast: SwitchTee new.
	rm addLast: Pump new.
	rm addLast: Sink new.
	(rm at: 1) outPort connect: (rm at: 2) inPort.
	(rm at: 2) outPort
		connect: ((rm at: 3)
				inPort).
	(rm at: 3) outPort connect: (rm at: 4) inPort.
	(rm at: 4) outPort connect: (rm at: 5) inPort.
	((rm at: 5)
		outPort)
		connect: (rm at: 6) inPort.
	(rm at: 6) outPort connect: (rm at: 7) inPort.
	(rm at: 2)
		startPumping: 1000.
	(rm at: 6)
		startPumping: 300.
	rm inspect.
	(rm at: 6) allConnectedInfoPipes inspect! !

!InfoPipeExamples class methodsFor: 'simple examples' stamp: 'Rik 2004.5'!
testy2
	"only use the basic components and Y components to construct a  
	staight pipeline"
	"InfoPipeExamples testy2"
	rm _ OrderedCollection new.
	rm addLast: SequentialSource new.
	rm addLast: SwitchTee new.
	rm addLast: Pump new.
	rm addLast: MixTee new.
	rm addLast: Sink new.
	(rm at: 1) outPort connect: (rm at: 2) inPort.
	((rm at: 2)
		portNamed: #output2)
		connect: (rm at: 3) inPort.
	(rm at: 3) outPort
		connect: ((rm at: 4)
				inPort).
	(rm at: 4) outPort connect: (rm at: 5) inPort.
	(rm at: 3)
		startPumping: 1000.
	rm inspect.
	(rm at: 3) allConnectedInfoPipes inspect! !

!InfoPipeExamples class methodsFor: 'simple examples' stamp: 'Rik 2004.5'!
testy3

"InfoPipeExamples testy3"
	"only use the basic components and Y components to construct a  
	broadcast pipeline"
	rm _ OrderedCollection new.
	rm addLast: SequentialSource new.
	rm addLast: Pump new.
	rm addLast: MulticastTee new.
	rm addLast: Sink new.
	rm addLast: Sink new.
	(rm at: 1) outPort connect: (rm at: 2) inPort.
	(rm at: 2) outPort connect: (rm at: 3) inPort.
	((rm at: 3)
		outPort)
		connect: (rm at: 4) inPort.
	((rm at: 3)
		portNamed: #output2)
		connect: (rm at: 5) inPort.
	(rm at: 2)
		startPumping: 1000.
	rm inspect.
	(rm at: 3) allConnectedInfoPipes inspect! !

!InfoPipeExamples class methodsFor: 'simple examples' stamp: 'Rik 2004.5'!
testy4
	"InfoPipeExamples testy4"
	"only use the basic components and Y components to construct a  
	unicast pipeline"
	rm _ OrderedCollection new.
	rm addLast: SequentialSource new.
	rm addLast: SwitchTee new.
	rm addLast: Pump new.
	rm addLast: Pump new.
	rm addLast: Sink new.
	rm addLast: Sink new.
	(rm at: 1) outPort connect: (rm at: 2) inPort.
	((rm at: 2)
		outPort)
		connect: (rm at: 3) inPort.
	((rm at: 2)
		portNamed: #output2)
		connect: (rm at: 4) inPort.
	(rm at: 3) outPort connect: (rm at: 5) inPort.
	(rm at: 4) outPort connect: (rm at: 6) inPort.
	(rm at: 3)
		startPumping: 1000.
	(rm at: 4)
		startPumping: 1000.
	rm inspect.
	(rm at: 3) allConnectedInfoPipes inspect! !

!InfoPipeExamples class methodsFor: 'simple examples' stamp: 'Rik 6/10/2004 00:00'!
testy5
	"InfoPipeExamples testy5"
	"only use the basic components and Y components to construct a multiplex pipeline"
	rm _ OrderedCollection new.
	rm addLast: SequentialSource new.
	rm addLast: SequentialSource new.
	rm addLast: Pump new.
	rm addLast: Pump new.
	rm addLast: MixTee new.
	rm addLast: Sink new.
	(rm at: 1) outPort connect: (rm at: 3) inPort.
	(rm at: 2) outPort connect: (rm at: 4) inPort.
	(rm at: 3) outPort connect: ((rm at: 5) inPort).
	(rm at: 4) outPort connect: ((rm at: 5) portNamed: #input2).
	(rm at: 5) outPort connect: (rm at: 6) inPort.
	(rm at: 3) startPumping: 1000.
	(rm at: 4) startPumping: 1000.
	rm inspect.
	(rm at: 6) allConnectedInfoPipes inspect! !

!InfoPipeExamples class methodsFor: 'simple examples' stamp: 'Rik 2004.5'!
testy6
"InfoPipeExamples testy6"
	"only use the basic components and Y components to construct a  
	gathering pipeline"
	rm _ OrderedCollection new.
	rm addLast: SequentialSource new.
	rm addLast: SequentialSource new.
	rm addLast: ZipTee new.
	rm addLast: Pump new.
	rm addLast: Sink new.
	(rm at: 1) outPort
		connect: ((rm at: 3)
				inPort).
	(rm at: 2) outPort
		connect: ((rm at: 3)
				portNamed: #input2).
	(rm at: 3)
		->> (rm at: 4)
		->> (rm at: 5).
	(rm at: 4)
		startPumping: 1000.
	rm inspect.
	(rm at: 2) allConnectedInfoPipes inspect! !

!InfoPipeExamples class methodsFor: 'simple examples' stamp: 'Rik 2004.5'!
testy7
	"InfoPipeExamples testy7"
	"only use the basic components and Y components to construct a  
	broadcast and	multiplex pipeline"
	rm _ OrderedCollection new.
	rm addLast: SequentialSource new.
	rm addLast: Pump new.
	rm addLast: MulticastTee new.
	rm addLast: MixTee new.
	rm addLast: Sink new.
	(rm at: 1)
		->> (rm at: 2).
	(rm at: 2)
		->> (rm at: 3).
	((rm at: 3)
		outPort)
		->> ((rm at: 4)
				inPort).
	((rm at: 3)
		portNamed: #output2)
		->> ((rm at: 4)
				portNamed: #input2).
	(rm at: 4)
		->> (rm at: 5).
	(rm at: 2)
		startPumping: 1000.
	rm inspect.
	(rm at: 2) allConnectedInfoPipes inspect! !


!InfoPipeTests methodsFor: 'initialization' stamp: 'Rik 2/17/2004 13:30'!
components
	components isNil
		ifTrue: [components _ Dictionary new].
	^ components! !

!InfoPipeTests methodsFor: 'initialization' stamp: 'Rik 2/13/2004 12:20'!
initialize
	components _ Dictionary new! !

!InfoPipeTests methodsFor: 'initialization' stamp: 'Rik 2/13/2004 13:15'!
ipn: aString
	^self thingNamed: aString

"
InfoPipe Named: 
Just an alias method to make less visual impact in its many uses
InfoPipeTests new ipn: #Source1
"
! !

!InfoPipeTests methodsFor: 'initialization' stamp: 'Rik 2/13/2004 16:34'!
ipn: aString put: anInfoPipe
	| aSym |
	aSym _ aString asSymbol.
	^components at: aSym put: anInfoPipe
! !

!InfoPipeTests methodsFor: 'initialization' stamp: 'Rik 2/19/2004 13:19'!
tearDown
	self components do: [ :ea | ea disconnect; release ].
	components _ nil.
	super tearDown! !

!InfoPipeTests methodsFor: 'initialization' stamp: 'Rik 2/29/2004 11:29'!
thingNamed: aString
	| aSym thingClass |
	aSym _ aString asSymbol.
	^components at: aSym ifAbsentPut: [
		thingClass _ self class classToUseFor: (aString copyFrom: 1 to: (aString size - 1)).
		thingClass new label: aString
		]
"
InfoPipeTests new thingNamed: #Source1
InfoPipeTests new thingNamed: 'Pump2'  (should ALSO work: I saw too many places where string were used)
InfoPipeTests new thingNamed: 'pump2'  (not encouraged, but easier to fix in one place)


Someday, we can worry about remote object access

"
! !


!InfoPipeClassTests methodsFor: 'CTC testing' stamp: 'md 3/26/2003 17:39'!
testClassComment
	self shouldnt: [self targetClass organization hasNoComment].! !

!InfoPipeClassTests methodsFor: 'CTC testing' stamp: 'md 3/25/2003 23:07'!
testNew
	self shouldnt: [self targetClass new] raise: Error.! !

!InfoPipeClassTests methodsFor: 'CTC testing' stamp: 'md 3/26/2003 17:24'!
testUnCategorizedMethods
	| categories slips  |
	categories := self categoriesForClass: self targetClass.
	slips := categories select: [:each | each = #'as yet unclassified'].
	self should: [slips isEmpty].	! !

!InfoPipeClassTests methodsFor: 'CTC Running' stamp: 'Rik 2/13/2004 13:17'!
setUp
	self resumeFromDeprecatedMethods: true.
	example _ self classToBeTested new! !

!InfoPipeClassTests methodsFor: 'CTC Running' stamp: 'Rik 2/17/2004 13:25'!
tearDown
	self resumeFromDeprecatedMethods: false.
	example _ nil.
	super tearDown! !

!InfoPipeClassTests methodsFor: 'CTC private' stamp: 'md 3/26/2003 17:10'!
categoriesForClass: aClass

 ^ aClass organization allMethodSelectors collect: 
			[:each |  aClass organization categoryOfElement: each].! !

!InfoPipeClassTests methodsFor: 'CTC private' stamp: 'md 3/6/2003 13:54'!
targetClass
  |className|

  className := self class name asText copyFrom: 0 to: self class name size - 4.
  ^ Smalltalk at: (className asString asSymbol).! !

!InfoPipeClassTests methodsFor: 'CTC Coverage' stamp: 'md 11/28/2003 14:59'!
classToBeTested
	^self targetClass! !

!InfoPipeClassTests methodsFor: 'CTC Coverage' stamp: 'brp 7/26/2003 16:35'!
selectorsNotTested

	^ self selectorsToBeTested difference: self selectorsTested.
! !

!InfoPipeClassTests methodsFor: 'CTC Coverage' stamp: 'brp 7/26/2003 17:36'!
selectorsTested
	| literals |
	literals _ Set new.
	self class
		selectorsAndMethodsDo: [ :s :m | (s beginsWith: 'test')
			ifTrue: [ literals addAll: (m literals select: [ :l | l isSymbol and: [l first isLowercase]]) ] ].
	^ literals! !

!InfoPipeClassTests methodsFor: 'CTC Coverage' stamp: 'brp 7/26/2003 17:22'!
selectorsToBeIgnored
	^ #(#DoIt #DoItIn:)! !

!InfoPipeClassTests methodsFor: 'CTC Coverage' stamp: 'brp 7/27/2003 12:40'!
selectorsToBeTested

	^ ( { self classToBeTested. self classToBeTested class } gather: [:c | c selectors]) 
			difference: self selectorsToBeIgnored! !

!InfoPipeClassTests methodsFor: 'CTC Tests' stamp: 'md 11/28/2003 15:03'!
MDtestCoverage

	| untested | 
	untested := self selectorsNotTested.
	self assert: untested isEmpty 
		description: untested size asString, ' selectors are not covered'.! !

!InfoPipeClassTests methodsFor: 'CTC Private' stamp: 'brp 8/6/2003 19:24'!
resumeFromDeprecatedMethods: autoResume
	"If true, make the default action for all Deprecation warnings to resume"

	| da |
	autoResume
		ifTrue: [Deprecation compiledMethodAt: #defaultAction ifAbsent: 
					[ Deprecation 
						addSelector: #defaultAction 
						withMethod: (Notification >> #defaultAction) ] ]
		ifFalse: [da _ Deprecation compiledMethodAt: #defaultAction ifAbsent: [].
				da == (Notification >> #defaultAction) 
					ifTrue: [ Deprecation removeSelectorSimply: #defaultAction] ]
				


! !


!InfoPipeCleanUpTest methodsFor: 'Tests' stamp: 'Rik 2/17/2004 12:40'!
testZombieInfoPipe
	| zomb |
	Smalltalk garbageCollect.
	self assert: (zomb _ InfoPipe allSubInstances) isEmpty.! !

!InfoPipeCleanUpTest methodsFor: 'Tests' stamp: 'Rik 2/20/2004 12:40'!
testZombieMode
	| zomb |
	Smalltalk garbageCollect.
	self assert: (zomb _ Mode allSubInstances) size <= 2! !

!InfoPipeCleanUpTest methodsFor: 'Tests' stamp: 'Rik 2/17/2004 12:41'!
testZombieMonitor
	| zomb |
	Smalltalk garbageCollect.
	self assert: (zomb _ Monitor allSubInstances) isEmpty.! !

!InfoPipeCleanUpTest methodsFor: 'Tests' stamp: 'Rik 2/20/2004 12:40'!
testZombiePort
	| zomb |
	Smalltalk garbageCollect.
	self assert: (zomb _ Port allSubInstances) size <= 1.! !


!InfoPipeTests class methodsFor: 'Testing' stamp: 'Rik 2/5/2004 14:09'!
isAbstract
	"Override to true if a TestCase subclass is Abstract and should not have
	TestCase instances built from it"

	^self sunitName = #InfoPipeTests
			! !

!InfoPipeTests class methodsFor: 'Instance Creation' stamp: 'Rik 2/13/2004 13:19'!
classToUseFor: aString
	^self classToUseForDict at: aString asLowercase asSymbol! !

!InfoPipeTests class methodsFor: 'Instance Creation' stamp: 'Rik 2/26/2004 14:36'!
classToUseForDict
	ClassToUseForDict isNil ifTrue: [
		ClassToUseForDict _ Dictionary new.
		ClassToUseForDict at: #pump put: Pump.
		ClassToUseForDict at: #source put: SequentialSource.
		ClassToUseForDict at: #sink put: Sink.
		ClassToUseForDict at: #pipe put: Pipe.
		ClassToUseForDict at: #netpipe put: NetPipe.
		ClassToUseForDict at: #split put: SwitchTee.
		ClassToUseForDict at: #switchtee put: SwitchTee.
		ClassToUseForDict at: #buff put: BoundedBuffer.
		ClassToUseForDict at: #buffer put: BoundedBuffer.
		ClassToUseForDict at: #limitedseq put: LimitedSequence.
		ClassToUseForDict at: #compound put: CompoundPipe.
		ClassToUseForDict at: #mixtee put: MixTee.
		].
	^ClassToUseForDict

"
InfoPipeTests classToUseForDict
InfoPipeTests initialize
"
! !

!InfoPipeTests class methodsFor: 'Instance Creation' stamp: 'Rik 2/13/2004 12:19'!
new
	^super new initialize! !

!InfoPipeTests class methodsFor: 'class initialization' stamp: 'Rik 2/13/2004 12:53'!
initialize
	ClassToUseForDict _ nil
	" 
	InfoPipeTests initialize
	"! !

!InfoPipeTests class methodsFor: 'Building Suites' stamp: 'Rik 2/13/2004 13:38'!
addTestsFor: classNameString toSuite: suite

	| cls  |
	cls _ Smalltalk at: classNameString ifAbsent: [ ^suite ].
	cls allSubclasses do: [ :each |
			each isAbstract ifFalse: [
					each addToSuiteFromSelectors: suite] ].
	cls isAbstract 
		ifFalse: [ cls addToSuiteFromSelectors: suite ].
	^suite
! !

!InfoPipeTests class methodsFor: 'Building Suites' stamp: 'Rik 2/13/2004 13:44'!
buildSuite
	| suite |
	suite _ TestSuite new.
	^ self isAbstract
		ifTrue: [
			suite name: self name asString.
			self withAllSubclassesDo: [:each |
				each isAbstract
						ifFalse: [each addToSuiteFromSelectors: suite]].
			suite]
		ifFalse: [self addToSuiteFromSelectors: suite]! !


!InfoPipeClassTests class methodsFor: 'CTC Testing' stamp: 'brp 7/27/2003 12:53'!
isAbstract
	"Override to true if a TestCase subclass is Abstract and should not have
	TestCase instances built from it"

	^self sunitName = #InfoPipeClassTests
			! !


!InfoPipeCleanUpTest class methodsFor: 'simple examples' stamp: 'Rik 2/26/2004 00:07'!
testc1
	"InfoPipeExamples testc1"
	"test compound pipe"
	| c s |
	c _ CompoundPipe fromComponent: Pump new ->> Pipe new ->> Pipe new ->> BoundedBuffer new ->> Pump new.
	SequentialSource new outPort
		->> (c inPort).
	(c outPort)
		->> (s _ Sink new) inPort.
	c startPumping: 500.
	s inspectPipeline.
	^ c! !


!LimitedSequenceTest methodsFor: 'initialization' stamp: 'Rik 2/13/2004 15:53'!
setUp
	example _ self classToBeTested upTo: 7.
! !

!LimitedSequenceTest methodsFor: 'Tests' stamp: 'Rik 2/13/2004 16:08'!
testReuse
	example limit: 3.
	self assert: example produce = 'Item 1'.
	self assert: example produce = 'Item 2'.
	self assert: example produce = 'Item 3'.
	self assert: example produce = #EndOfData.
	self assert: example produce = #EndOfData.
	example limit: 7.
	self assert: example produce = 'Item 4'.
	self assert: example produce = 'Item 5'.
	self assert: example produce = 'Item 6'.
	self assert: example produce = 'Item 7'.
	self assert: example produce = #EndOfData.
	self assert: example produce = #EndOfData.
	self assert: example produce = #EndOfData.! !

!LimitedSequenceTest methodsFor: 'Tests' stamp: 'Rik 2/13/2004 16:03'!
testSequence
	self assert: example produce = 'Item 1'.
	self assert: example produce = 'Item 2'.
	self assert: example produce = 'Item 3'.
	self assert: example produce = 'Item 4'.
	self assert: example produce = 'Item 5'.
	self assert: example produce = 'Item 6'.
	self assert: example produce = 'Item 7'.
	self assert: example produce = #EndOfData.
	self assert: example produce = #EndOfData.
	self assert: example produce = #EndOfData.! !


!MergePipe methodsFor: 'initialization' stamp: 'Rik 6/2/2004 12:55'!
initializeInPorts
	| inMode tempPort |
	inMode _ self inPortMode new.
	(1 to: self mergeNumber)
		do: [:ix | 
			tempPort _ InPort ownedBy: self.
			tempPort mode: inMode.
			self portNamed: (('input' , ix asString) as: Symbol) put: tempPort].
! !


!MergePipe class methodsFor: 'instance creation' stamp: 'Rik 5/17/2004 11:56'!
new
	^ self newMerge: 2! !

!MergePipe class methodsFor: 'instance creation' stamp: 'Rik 5/17/2004 11:57'!
newMerge: branches 
	| rslt |
	rslt _ self basicNew.
	rslt mergeNumber: branches.
	rslt initialize.
	^ rslt! !


!MixTee methodsFor: 'initialization' stamp: 'Rik 2/19/2004 00:20'!
inPortMode
	^Passive! !

!MixTee methodsFor: 'initialization' stamp: 'Rik 2/18/2004 23:31'!
outPortMode
	^Active! !


!Mode methodsFor: 'gomi' stamp: 'Rik 5/12/2004 16:43'!
is: aMode 
self gomi.
	self = aMode
		ifTrue: [^ true].
	self class = aMode class
		ifTrue: [^ true].
	^ false! !


!Morph methodsFor: 'testing' stamp: 'Rik 4/7/2004 17:17'!
isPbInPort
	^false! !

!Morph methodsFor: 'testing' stamp: 'Rik 4/7/2004 17:19'!
isPbOutPort
	^false! !

!Morph methodsFor: 'testing' stamp: 'Rik 3/8/2004 08:05'!
isPbPort
	^false! !


!NetPipe methodsFor: 'initialization' stamp: 'Rik 2/18/2004 23:53'!
initializeInPorts
	| in |
	self socket: Socket newUDP.
	self socket setPort: Socket wildcardPort.
	self proxyPort: self socket port.
	"proxyProcess _ [self listeningLoop] fork."
	in _ (self remoteObject: 'NetInPort')
				ownedBy: self.
	in mode: (self remoteObject: 'Passive') new.
	self ports at: #input1 put: in.
! !

!NetPipe methodsFor: 'initialization' stamp: 'Rik 2/18/2004 23:51'!
outPortMode
	^Passive! !


!Pipe methodsFor: 'initialization' stamp: 'Rik 2/19/2004 00:03'!
initializePorts
	| vmode |
	self ports at: #input1
		put: ((InPort ownedBy: self)
				mode: (vmode _ VarMode new)).
	self ports at: #output1
		put: ((OutPort ownedBy: self)
				mode: (InverseMode of: vmode))! !


!Filter methodsFor: 'pipe operations' stamp: 'Rik 5/17/2004 20:00'!
push: anItem 
	self afterLatency: nil.
	self outPort push: (function value: anItem)! !

!Filter methodsFor: 'initialization' stamp: 'Rik 5/17/2004 00:20'!
defaultFunction
	^ [ :item | item ]! !

!Filter methodsFor: 'initialization' stamp: 'Rik 5/17/2004 00:21'!
initialize
	super initialize.
	self function: self defaultFunction! !


!MutableFilter methodsFor: 'initialization' stamp: 'Rik 2/18/2004 23:43'!
inPortMode
	^Passive! !

!MutableFilter methodsFor: 'initialization' stamp: 'Rik 2/18/2004 23:43'!
outPortMode
	^Passive! !


!MutableFilterNP methodsFor: 'initialization' stamp: 'Rik 2/18/2004 23:45'!
outPortMode
	^Active! !


!MutableFilterPN methodsFor: 'initialization' stamp: 'Rik 2/18/2004 23:47'!
inPortMode
	^Active ! !


!MutableFilterPP methodsFor: 'initialization' stamp: 'Rik 2/18/2004 23:47'!
inPortMode
	^Active ! !

!MutableFilterPP methodsFor: 'initialization' stamp: 'Rik 2/18/2004 23:47'!
outPortMode
	^Active ! !


!PipeLineTest methodsFor: 'initialize-release' stamp: 'Rik 2/13/2004 16:29'!
setUp
	(self ipn: #source1 put: (LimitedSequence upTo: 7))
		->> (self ipn: #pump1)
		->> (self ipn: #pipe1)
		->> (self ipn: #pipe2) 
		->> (self ipn: #buff1)
		->> (self ipn: #pump2)
		->> (self ipn: #sink1).
! !

!PipeLineTest methodsFor: 'Tests' stamp: 'Rik 2/17/2004 12:23'!
test1Production
	self assert: (self ipn: #sink1) interarrivalTimes isEmpty.
	(self ipn: #pump1) startPumping: 5.
	(self ipn: #pump2) startPumping: 3.
	(Delay forMilliseconds: 9) wait.
	self assert: (self ipn: #sink1) interarrivalTimes size >= 1.
! !

!PipeLineTest methodsFor: 'Tests' stamp: 'Rik 2/13/2004 16:47'!
test1x
	(self ipn: #pump1) startPumping: 5.
	(self ipn: #pump2) startPumping: 3.

"
	oldConnex _ NCConnectorMorph allInstances.
	self shouldnt: [sysWin _ pump1 inspectPipeline] raise: Error.

	sysWin delete.
	newConnex _ NCConnectorMorph allInstances asSet removeAll: oldConnex.
	self assert: newConnex isEmpty.
	newConnex do: [ :ea | ea delete ].
"! !

!PipeLineTest methodsFor: 'Tests' stamp: 'Rik 2/13/2004 13:23'!
testConnections
	self assert: (self ipn: #source1) allConnectedInfoPipes size = 7. 
	self assert: (self ipn: #pump1) allConnectedInfoPipes size = 7. 
	self assert: (self ipn: #pump2) allConnectedInfoPipes size = 7. 
	self assert: (self ipn: #pipe1) allConnectedInfoPipes size = 7. 
	self assert: (self ipn: #pipe2) allConnectedInfoPipes size = 7. 
	self assert: (self ipn: #sink1) allConnectedInfoPipes size = 7. 
	self assert: (self ipn: #buff1) allConnectedInfoPipes size = 7. ! !

!PipeLineTest methodsFor: 'Tests' stamp: 'Rik 2/17/2004 12:33'!
testEndOfData
	(self ipn: #pump1) startPumping: 5.
	(self ipn: #pump2) startPumping: 3.

	"(Delay forMilliseconds: 20000) wait.   It's not the time: 20 seconds was not enough either. -Rik "
	8 timesRepeat: [(Delay forMilliseconds: 13) wait].  
	self assert: (self ipn: #sink1) contents last = #EndOfData.
! !


!Port methodsFor: 'accessing' stamp: 'Rik 2/20/2004 14:36'!
disconnect
	self connectedTo connectedTo: OpenEnd new.
	self connectedTo: OpenEnd new! !

!Port methodsFor: 'testing' stamp: 'Rik 5/19/2004 01:57'!
isOutput
	^ false! !

!Port methodsFor: 'type checking' stamp: 'Rik 6/3/2004 14:37'!
canConnectTo: aPort 
	^(self mode isCompatibleWith: aPort mode)
		ifTrue: [true]
		ifFalse: [ self mode asString , ' cannot connect to ', aPort mode asString. false ]! !

!Port methodsFor: 'initialize-release' stamp: 'Rik 2/19/2004 13:32'!
release
	mode _ owner _ connectedTo _ nil! !


!InPort methodsFor: 'testing' stamp: 'Rik 2/26/2004 22:54'!
inPort
	"I am an inport"! !


!CompoundInPort methodsFor: 'initialize-release' stamp: 'Rik 2/19/2004 13:35'!
release
	super release.
	pseudoOwner _ nil! !


!NetInPort methodsFor: 'initialize-release' stamp: 'Rik 2/19/2004 13:40'!
release
	super release.
	socket ifNotNil: [
		socket destroy; release.
		socket _ nil]! !


!OutPort methodsFor: 'configuration' stamp: 'Rik 2/26/2004 22:53'!
->> aPortOrPipe
	self connect: aPortOrPipe inPort! !

!OutPort methodsFor: 'configuration' stamp: 'Rik 5/25/2004 22:23'!
connect: aPort 
	"answer whether successful at connecting"

	aPort isInput
		ifTrue: 
			[self disconnect.
			(self canConnectTo: aPort)
				ifTrue: 
					[self connectedTo: aPort.
					aPort connectedTo: self.
					^true]
				"ifFalse: [self inform: 'Incompatible types. Cannot be connected'.]"].
	^false
	! !

!OutPort methodsFor: 'configuration' stamp: 'Rik 6/7/2004 12:31'!
gripeOrConnect: aPort 
	"answer whether successful at connecting"

	| gripe |
	gripe _ 'must connect output to input'.	
	aPort isInput ifTrue:  [
		self disconnect.
		(gripe _ self whyNotConnectTo: aPort)
			isEmpty ifTrue:  [
				self connectedTo: aPort.
				aPort connectedTo: self]
				].
	^gripe
	! !

!OutPort methodsFor: 'testing' stamp: 'Rik 5/19/2004 01:58'!
isOutput
	^true! !


!CompoundOutPort methodsFor: 'initialize-release' stamp: 'Rik 2/19/2004 13:36'!
release
	super release.
	pseudoOwner _ nil! !


!PseudoPipe methodsFor: 'accessing' stamp: 'H.J 11/20/2000 13:52'!
realPort: aPort 
	realPort _ aPort! !


!InputPseudoPipe methodsFor: 'pipe operations' stamp: 'H.J 11/20/2000 22:20'!
pull
	^ realPort pull! !

!InputPseudoPipe methodsFor: 'pipe operations' stamp: 'H.J 11/20/2000 22:22'!
push: anItem 
	"push anItem into the pipe. The appropriate action is to push 
	anItem
	onto this pipe's output."
	self afterLatency: nil.
	self outPort push: anItem! !

!InputPseudoPipe methodsFor: 'accessing' stamp: 'H.J 11/20/2000 14:51'!
inPort
	self shouldNotImplement! !

!InputPseudoPipe methodsFor: 'initialization' stamp: 'Rik 5/19/2004 02:08'!
initializeInPorts
	self ports  "Just make the empty collection"! !

!InputPseudoPipe methodsFor: 'initialization' stamp: 'Rik 2/18/2004 23:16'!
outPortMode
	^VarMode! !


!OutputPseudoPipe methodsFor: 'pipe operations' stamp: 'H.J 11/20/2000 22:22'!
pull
	"answers anItem obtained from this pipe. It is obtained by  
	pulling
	from this pipe's input"
	^ self afterLatency: self inPort pull! !

!OutputPseudoPipe methodsFor: 'pipe operations' stamp: 'H.J 11/20/2000 13:55'!
push: anItem 
	realPort push: anItem! !

!OutputPseudoPipe methodsFor: 'accessing' stamp: 'H.J 11/20/2000 14:53'!
outPort
	self shouldNotImplement! !

!OutputPseudoPipe methodsFor: 'initialization' stamp: 'Rik 2/18/2004 23:55'!
inPortMode
	^VarMode! !

!OutputPseudoPipe methodsFor: 'initialization' stamp: 'Rik 5/25/2004 13:41'!
initializeOutPorts
	" no output port - just empty collection"! !


!PseudoPipe class methodsFor: 'instance creation' stamp: 'H.J 11/20/2000 13:39'!
new
	self error: 'a PseudoPipe can only be created by "InputPseudoPipe connectedTo: aPort" or "OutputPseudoPipe connectedTo: aPort"'! !


!InputPseudoPipe class methodsFor: 'instance creation' stamp: 'H.J 11/20/2000 15:26'!
connectedTo: aPort 
	| p |
	p _ self basicNew initialize.
	p outPort connect: aPort.
	^ p! !


!OutputPseudoPipe class methodsFor: 'instance creation' stamp: 'H.J 11/20/2000 15:27'!
connectedTo: aPort 
	| p |
	p _ self basicNew initialize.
	aPort connect: p inPort.
	^ p! !


!Pump methodsFor: 'pump operations' stamp: 'Rik 2/27/2004 01:50'!
stroke
	| item |
	item _ self afterLatency: self inPort pull.
	item = #EndOfData ifTrue: [self changed: #EndOfData].
	self outPort push: item.
	strokes _ strokes + 1! !

!Pump methodsFor: 'initialize-release' stamp: 'Rik 2/19/2004 14:19'!
inPortMode
	^Active! !

!Pump methodsFor: 'initialize-release' stamp: 'Rik 2/19/2004 00:04'!
outPortMode
	^Active! !

!Pump methodsFor: 'initialize-release' stamp: 'Rik 2/20/2004 08:25'!
release
	self stopPumping.
	super release.
	threadSack ifNotNil: [ threadSack do: [ :eaProc | eaProc terminate ] ].
	threadQueue  ifNotNil: [ threadQueue terminateProcess].
	strokeDelay _ threadQueue _ threadSack _ nil.
! !

!Pump methodsFor: 'printing' stamp: 'Rik 2/22/2004 08:27'!
isPumping
	^pumper notNil! !

!Pump methodsFor: 'printing' stamp: 'Rik 2/22/2004 08:26'!
printOn: aStream
	super printOn: aStream.
	self isPumping ifTrue: [ aStream nextPutAll: '_@^']
	! !


!Sink methodsFor: 'initialization' stamp: 'Rik 2/18/2004 23:25'!
inPortMode
	^ Passive ! !

!Sink methodsFor: 'initialization' stamp: 'Rik 2/6/2004 10:49'!
initialize
	super initialize.
	bitBucket _ OrderedCollection new.
	interarrivalTimes _ OrderedCollection new.
	lastArrivalTime _ Time millisecondClockValue.
	itemCount _ 0.
	self capacity: self defaultCapacity! !

!Sink methodsFor: 'initialization' stamp: 'Rik 5/25/2004 13:41'!
initializeOutPorts
	" no output port - just an empty collection"! !

!Sink methodsFor: 'accessing' stamp: 'Rik 2/13/2004 16:44'!
interarrivalTimes
	^interarrivalTimes! !

!Sink methodsFor: 'accessing' stamp: 'Rik 2/13/2004 16:45'!
lastArrivalTime
	^lastArrivalTime! !


!FileSink methodsFor: 'initialization' stamp: 'Rik 2/19/2004 01:59'!
initialize
	super initialize.
	bitBucket _ FileStream newFileNamed: self fileName
! !


!SinkTest methodsFor: 'Tests' stamp: 'Rik 2/6/2004 10:56'!
testNoOutput
	self assert: example latency = 0.
	self should: [example outPort] raise: Error.
	self assert: example outPorts isEmpty! !


!Active methodsFor: 'operations' stamp: 'Rik 5/12/2004 16:42'!
opposite
	^ Passive singleInstance! !

!Active methodsFor: 'type checking' stamp: 'Rik 5/12/2004 16:42'!
isCompatibleWith: aMode 
	aMode myValue = Passive singleInstance ifTrue: [^ true].
	aMode myValue = Active singleInstance ifTrue: [^ false].
	^ aMode bind: self opposite! !


!Passive methodsFor: 'type checking' stamp: 'Rik 5/12/2004 16:41'!
isCompatibleWith: aMode 
	aMode myValue = Active singleInstance ifTrue: [^ true].
	aMode myValue = Passive singleInstance ifTrue: [^ false].
	^ aMode bind: self opposite! !

!Passive methodsFor: 'operations' stamp: 'Rik 5/12/2004 16:40'!
opposite
	^ Active singleInstance! !

!Passive methodsFor: 's2s' stamp: 'Rik 3/11/2004 12:19'!
isPassedByValue
	^true.! !


!SoleInstanceMode class methodsFor: 'instance creation' stamp: 'Rik 5/12/2004 16:40'!
new
	^self singleInstance! !

!SoleInstanceMode class methodsFor: 'instance creation' stamp: 'Rik 5/12/2004 16:39'!
singleInstance
	"This is a singleton object, so we just return my only instance."
	soleInstance isNil ifTrue: [soleInstance _ super new].
	^ soleInstance! !


!Source methodsFor: 'initialization' stamp: 'Rik 5/19/2004 02:10'!
initializeInPorts
	self ports  "Just make the empty collection"! !

!Source methodsFor: 'initialization' stamp: 'Rik 2/19/2004 00:06'!
outPortMode
	^Passive! !


!FileSource methodsFor: 'initialization' stamp: 'Rik 2/6/2004 11:07'!
initialize
	super initialize.
	fileStream _ CrLfFileStream readOnlyFileNamed: fileName! !


!SequentialSource methodsFor: 'pipe operations' stamp: 'Rik 2/27/2004 00:20'!
produce
	maxUsed _ maxUsed + 1.
	^ self label , maxUsed asString! !

!SequentialSource methodsFor: 'initialization' stamp: 'Rik 2/6/2004 11:05'!
initialize
	super initialize.
	maxUsed _ 0! !


!LimitedSequence methodsFor: 'initialization' stamp: 'Rik 2/17/2004 12:17'!
initialize
	super initialize.
	limit _ 7	"an odd default"! !

!LimitedSequence methodsFor: 'initialization' stamp: 'Rik 2/13/2004 15:26'!
limit
	^limit! !

!LimitedSequence methodsFor: 'initialization' stamp: 'Rik 2/13/2004 15:26'!
limit: maxValue
	limit _ maxValue! !

!LimitedSequence methodsFor: 'pipe operations' stamp: 'Rik 2/27/2004 01:28'!
produce
	^maxUsed >= limit ifFalse: [super produce] ifTrue: [#EndOfData] ! !


!LimitedSequence class methodsFor: 'instance creation' stamp: 'Rik 2/13/2004 15:32'!
upTo: max
	^self new limit: max! !


!SourceTest methodsFor: 'Tests' stamp: 'Rik 2/6/2004 10:43'!
testNoInput
	self assert: example latency = 0.
	self should: [example inPort] raise: Error.
	self assert: example inPorts isEmpty! !


!SplitPipe methodsFor: 'initialization' stamp: 'Rik 6/2/2004 09:19'!
inPortMode
self gomi.
	^ Passive ! !

!SplitPipe methodsFor: 'initialization' stamp: 'Rik 6/2/2004 09:19'!
initializeOutPorts
	| outMode tempPort |
self gomi.
	outMode _ self outPortMode new.
	(1 to: splitNumber) do: [:ix | 
			tempPort _ OutPort ownedBy: self.
			tempPort mode: outMode.
			self ports at: ('output' , ix asString) asSymbol
					put: tempPort].
! !

!SplitPipe methodsFor: 'initialization' stamp: 'Rik 6/2/2004 09:18'!
initializePorts
	| vmode tempPort |
	self ports at: #input1
		put: ((InPort ownedBy: self)
				mode: (vmode _ VarMode new)).

	(1 to: splitNumber) do: [:ix | 
			tempPort _ OutPort ownedBy: self.
			tempPort mode: (InverseMode of: vmode).
			self ports at: ('output' , ix asString) asSymbol
					put: tempPort].
! !

!SplitPipe methodsFor: 'initialization' stamp: 'Rik 6/2/2004 09:19'!
outPortMode
self gomi.
	^ Passive ! !



!SplitPipe class methodsFor: 'instance creation' stamp: 'Rik 5/17/2004 11:56'!
new
	^ self newSplit: 2! !

!SplitPipe class methodsFor: 'instance creation' stamp: 'Rik 5/25/2004 00:24'!
newForPb: aPBPartMorph
	^(self newSplit: aPBPartMorph outPortCount) pb: aPBPartMorph
! !


!SquareFilter methodsFor: 'initialization'!
defaultFunction
	^ [ :item | item squared ]! !

!SquareFilter methodsFor: 'goofy'!
goofy
	^1234567! !


!SwitchTee methodsFor: 'initialization' stamp: 'Rik 2/19/2004 00:16'!
inPortMode
	^ Active ! !

!SwitchTee methodsFor: 'initialization' stamp: 'Rik 2/19/2004 00:17'!
outPortMode
	^ Passive ! !


!TopoSort methodsFor: 'adding' stamp: 'Rik 2/29/2004 18:50'!
add: anObject 
	| row |
	row _ 1.
	anObject inConnectedTo do: [ :each |
		(self rowOf: each) ifNotNilDo: [ :ero | row _ row max: (ero+1) ] ].
	rows add: (row@0 -> anObject).
	
	self bumpThoseBelow: anObject.
	rows reSort.! !

!TopoSort methodsFor: 'adding' stamp: 'Rik 2/29/2004 19:14'!
bumpThoseBelow: anObject
	| row index eix |
	(index _ rows findFirst: [ :each |  each value = anObject ]) = 0 ifTrue: [^self].
	row _ (rows at: index) key x.
	anObject outConnectedTo do: [ :out |
		(eix _ rows findFirst: [ :each |  each value = out ]) = 0 ifFalse: [
			(((rows at: eix) key x = row) or: [
				(out inConnectedTo select: [ :revers | self includes: revers
				 ]) size = 1 ]) 
			ifTrue: [
				(rows at: eix) key: (row + 1)@0.
				self bumpThoseBelow: (rows at: eix) value ]
			] ]! !

!TopoSort methodsFor: 'adding' stamp: 'Rik 2/29/2004 19:10'!
includes: anObject 
	rows detect: [ :assn | assn value == anObject] ifNone: [^false].
	^true! !

!TopoSort methodsFor: 'adding' stamp: 'Rik 2/29/2004 18:42'!
rowOf: anObject 
	^(rows detect: [ :assn | assn value == anObject] ifNone: [^nil]) key x! !

!TopoSort methodsFor: 'placing' stamp: 'Rik 2/29/2004 16:56'!
places
	"answer a collection of Point->Pipe
	where Point is the row, column of the pipe"
	| row aro col |
	row _ 0.
	rows do: [ :assn |
		(aro _ assn key x) = row ifFalse: [
			row _ aro.
			col _ 1].
		assn key: aro@col.
		col _ col + 1
		].
	^rows! !

!TopoSort methodsFor: 'initialize-release' stamp: 'Rik 2/29/2004 14:54'!
initialize
	rows _ SortedCollection
				sortBlock: [:a :b |
					a key x < b key x
						or: [a key x = b key x
								and: [a key y < b key y]]]! !

!TopoSort methodsFor: 'printing' stamp: 'Rik 2/29/2004 10:59'!
printOn: aStream
	super printOn: aStream.
	rows do: [ :ea |
		aStream cr; print: ea]! !


!TopoSort class methodsFor: 'instance creation' stamp: 'Rik 2/27/2004 14:27'!
new
	^super new initialize! !


!UserPromptingTest methodsFor: 'Tests' stamp: 'Rik 2/29/2004 08:12'!
manualTest: aSymbol
	self setTestSelector: aSymbol.
	self setUp.
	sysWin _ self components someElement inspectPipeline.
	sysWin setLabel: self class name.
	super performTest

	"
	Compound3Test new manualTest: #testCompound
	"! !

!UserPromptingTest methodsFor: 'Tests' stamp: 'Rik 2/26/2004 23:25'!
performTest
	sysWin _ self components someElement inspectPipeline.
	sysWin setLabel: self class name.
	super performTest.
	sysWin delete! !


!Compound3Test methodsFor: 'Tests' stamp: 'Rik 2/26/2004 23:57'!
testCompound
	(self ipn: #pump1) startPumping: 50.
	(self ipn: #pump2) startPumping: 30.
	(self ipn: #pump3) startPumping: 50.
	(self ipn: #pump4) startPumping: 30.
	self assert: (self confirm: 'Is compound pumping?').
! !

!Compound3Test methodsFor: 'initialize-release' stamp: 'Rik 2/26/2004 23:56'!
setUp
	| cp p1 p2 p3 p4 |
	(self ipn: #compound1 put: (
		cp _ CompoundPipe fromComponent: 
			(self ipn: #mixtee1)
				->> (self ipn: #buff1)
				->> (self ipn: #switchtee2) )).
	(self ipn: #limitedSeq1)  ->> (p1 _ self ipn: #pump1).
	p1 ->> cp.
	(cp portNamed: #output2) ->> (p2 _ self ipn: #pump2). 
	p2 ->> (self ipn: #sink1).
	(self ipn: #limitedSeq3)  ->> (p3 _ self ipn: #pump3).
	p3 ->> (cp portNamed: #input2).
	(cp outPort) ->> (p4 _ self ipn: #pump4).
	p4 ->> (self ipn: #sink2).
! !


!Compound4Test methodsFor: 'Tests' stamp: 'Rik 2/27/2004 00:15'!
testCompound

	(self ipn: #compound1) startPumping: 500.
	(self ipn: #pump2) startPumping: 500.
	(self ipn: #pump3) startPumping: 300.
	self assert: (self confirm: 'Is compound pumping?').
! !

!Compound4Test methodsFor: 'initialize-release' stamp: 'Rik 5/19/2004 01:56'!
setUp
	| p1 c1 p2 p3 |
	(self ipn: #switchtee1)
		->> (p1 _ self ipn: #pump1)
		->> ( self ipn: #mixtee1) .
	(self ipn: #compound1 put: (
		c1 _ CompoundPipe fromComponent: p1)).

	((self ipn: #limitedSeq1) label: 'limitedA ') ->> c1.

	c1 ->>  (self ipn: #sink1).
	(c1 portNamed: #output2) ->> (p2 _ self ipn: #pump2).
	p2 ->> (self ipn: #sink2).
	((self ipn: #limitedSeq2) label: 'Seq B'; limit: 19)->> (p3 _ self ipn: #pump3).
	p3 ->> (c1 portNamed: #input2).! !


!CompoundPipeTest methodsFor: 'Tests' stamp: 'Rik 2/26/2004 23:26'!
testCompound
	(self ipn: #compound1) startPumping: 50.
	self assert: (self confirm: 'Is compound pumping?').
! !

!CompoundPipeTest methodsFor: 'initialize-release' stamp: 'Rik 2/26/2004 00:52'!
setUp
	| cp |
	(self ipn: #compound1 put: (
		cp _ CompoundPipe fromComponent: 
			(self ipn: #pump1)
				->> (self ipn: #pipe1)
				->> (self ipn: #pipe2) 
				->> (self ipn: #buff1)
				->> (self ipn: #pump2) )).

	(self ipn: #limitedSeq1) outPort
		->> cp inPort.
	cp outPort
		->> (self ipn: #sink1) inPort.
! !


!CompoundTeeTest methodsFor: 'Tests' stamp: 'Rik 2/26/2004 23:12'!
testCompound
	| win |
	win _ (self ipn: #compound1) inspectPipeline.
	win setLabel: self class name.
	(self ipn: #pump1) startPumping: 500.
	(self ipn: #pump2) startPumping: 300.
	self assert: (self confirm: 'Is compound pumping?').
	win delete
! !

!CompoundTeeTest methodsFor: 'initialize-release' stamp: 'Rik 5/19/2004 01:18'!
setUp
	| cp p1 p2 |
	(self ipn: #compound1 put: (
		cp _ CompoundPipe fromComponent: 
			(self ipn: #mixtee1)
				->> (self ipn: #buff1)
				->> (self ipn: #switchtee1) )).

	(self ipn: #limitedSeq1) ->> (p1 _ self ipn: #pump1).
	p1 outPort ->> cp inPort.
	(cp portNamed: #output2) ->> (p2 _ self ipn: #pump2) inPort.

	p2 ->> (self ipn: #sink1).
! !


!LimitedStopTest methodsFor: 'Tests' stamp: 'Rik 2/27/2004 00:50'!
testStoppingAtLimit
	(self ipn: #pump1) startPumping: 500.
	self assert: (self confirm: 'Does it stop pumping?').
! !

!LimitedStopTest methodsFor: 'initialization' stamp: 'Rik 2/27/2004 01:44'!
manualTest
	| p1 |
	((self ipn: #limitedSeq1) limit: 13)
		->> (p1 _ self ipn: #pump1)
		->> (self ipn: #sink1).
	p1 inspect.
	DrySwitch on: p1.
	p1 startPumping

"
LimitedStopTest  new manualTest
"
! !

!LimitedStopTest methodsFor: 'initialization' stamp: 'Rik 2/27/2004 01:22'!
setUp
	| p1 |
	((self ipn: #limitedSeq1) limit: 13)
		->> (p1 _ self ipn: #pump1)
		->> (self ipn: #sink1).
	DrySwitch on: p1.
! !


!MixTeeTest methodsFor: 'Tests' stamp: 'Rik 2/27/2004 23:11'!
testMixing
	(self ipn: #pump1) startPumping: 1000.
	(self ipn: #pump2) startPumping: 1234.
	self assert: (self confirm: 'Is it mixing?').
! !

!MixTeeTest methodsFor: 'initialization' stamp: 'Rik 5/19/2004 01:54'!
setUp
	| mix1 p2 |
	((self ipn: #limitedSeq1) label: 'limA')
		->> (self ipn: #pipe0)
		->> (self ipn: #pump1)
		->> (self ipn: #pipe1)
		->> (mix1 _ self ipn: #mixtee1)
		->> (self ipn: #pipe2)
		->> (self ipn: #sink1).
	((self ipn: #limitedSeq2) label: 'limB')
		->> (self ipn: #pipe3)
		->> (p2 _ self ipn: #pump2).
	p2 ->> (mix1 portNamed: #input2).
	! !


!PipeLineTest2 methodsFor: 'initialize-release' stamp: 'Rik 2/20/2004 12:52'!
setUp
	(self ipn: #pump1)
		->> (self ipn: #pipe1)
		->> (self ipn: #buff1)
		->> (self ipn: #pipe2)
		->> (self ipn: #pump1).
! !

!PipeLineTest2 methodsFor: 'Tests' stamp: 'Rik 2/29/2004 07:57'!
manualShortCycle
	| win |
	self setUp.
	win _ (self ipn: #pump1) inspectPipeline.
	win setLabel: self class name.
	(self ipn: #pump1) startPumping.
	(self confirm: 'Is it pumping in a cycle?').
	"
	PipeLineTest2 new manualShortCycle
	"! !

!PipeLineTest2 methodsFor: 'Tests' stamp: 'Rik 2/20/2004 12:55'!
testConnections
	self assert: (self ipn: #pump1) allConnectedInfoPipes size = 4. 
! !

!PipeLineTest2 methodsFor: 'Tests' stamp: 'Rik 2/26/2004 23:11'!
testShortCycle
	| win |
	win _ (self ipn: #pump1) inspectPipeline.
	win setLabel: self class name.
	(self ipn: #pump1) startPumping.
	(Delay forSeconds: 7) wait.
	self assert: (self confirm: 'Is it pumping in a cycle?').
	win delete! !


!ZipTee methodsFor: 'initialization' stamp: 'Rik 2/19/2004 00:22'!
inPortMode
	^Active! !

!ZipTee methodsFor: 'initialization' stamp: 'Rik 2/19/2004 00:23'!
outPortMode
	^Passive! !


!ZipTee reorganize!
('accessing' pull)
('initialization' inPortMode outPortMode)
!


!Pump reorganize!
('pump operations' addThread addThread: faster removeThread removeThread: slower startPumping startPumping: stopPumping stroke stroke: strokeInterval strokeInterval:)
('initialize-release' defaultStrokeInterval inPortMode initialize outPortMode release)
('testing' isActive)
('printing' isPumping printOn:)
!


!Port reorganize!
('accessing' connectedTo connectedTo: disconnect infoPipeConnectedTo mode mode: owner owner: recentValue recentValue:)
('testing' isInput isOpen isOpenEnd isOutput)
('printing' printOn:)
('type checking' canConnectTo: whyNotConnectTo:)
('initialize-release' initialize release)
!


!Mode reorganize!
('type checking' bind: isCompatibleWith:)
('operations' opposite)
('printing' printOn:)
('accessing' myValue myValue:)
('gomi' is:)
!

InfoPipeTests initialize!
Magnitude subclass: #InfoPipe
	instanceVariableNames: 'uid label latency ports pb '
	classVariableNames: 'LastUid '
	poolDictionaries: ''
	category: 'InfoPipes-Basic'!

!InfoPipe reorganize!
('clone' clone copyPortsName:)
('pipe operations' afterLatency: pull push:)
('user interface' addConnectorsOnPipes:widget:inspectors: defaultLabelForInspector inspectPipeline inspectPipelinex inspector inspectorIn: inspectorIn:at: placesFor:)
('printing' label label: printIDOn: printOn:)
('initialize-release' inPortMode initialize initializeClone: initializeInPorts initializeOutPorts initializePorts initializeUid outPortMode release)
('gomi' inPortAt: nameOfInPort: nameOfOutPort: openInPorts openOutPorts outPortAt: replaceInPortName:with: replaceOutPortName:with:)
('accessing' disconnect inConnectedTo inPorts latency latency: nameOfPort: openPorts outConnectedTo outPorts portsConnectedTo)
('testing' isActive)
('configuration' ->> allConnectedInfoPipes connectedInfoPipes:)
('networking' exportAs:)
('comparing' < = hash)
('plumbing' pb pb: pbClass pbPart)
('re-ports' inPort outPort portNamed: portNamed:put: ports)
!

